Index: branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/C14b/par_c14b.F90
===================================================================
--- branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/C14b/par_c14b.F90	(revision 3677)
+++ branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/C14b/par_c14b.F90	(revision 3680)
@@ -6,9 +6,4 @@
    !! History :   2.0  !  2008-12  (C. Ethe, G. Madec)  revised architecture
    !!----------------------------------------------------------------------
-   USE par_lobster, ONLY : jp_lobster      !: number of tracers in LOBSTER
-   USE par_lobster, ONLY : jp_lobster_2d   !: number of 2D diag in LOBSTER
-   USE par_lobster, ONLY : jp_lobster_3d   !: number of 3D diag in LOBSTER
-   USE par_lobster, ONLY : jp_lobster_trd  !: number of biological diag in LOBSTER
-
    USE par_pisces , ONLY : jp_pisces       !: number of tracers in PISCES
    USE par_pisces , ONLY : jp_pisces_2d    !: number of 2D diag in PISCES
@@ -24,8 +19,8 @@
    IMPLICIT NONE
 
-   INTEGER, PARAMETER ::   jp_lb      = jp_lobster     + jp_pisces     + jp_cfc     !: cum. number of pass. tracers
-   INTEGER, PARAMETER ::   jp_lb_2d   = jp_lobster_2d  + jp_pisces_2d  + jp_cfc_2d  !:
-   INTEGER, PARAMETER ::   jp_lb_3d   = jp_lobster_3d  + jp_pisces_3d  + jp_cfc_3d  !:
-   INTEGER, PARAMETER ::   jp_lb_trd  = jp_lobster_trd + jp_pisces_trd + jp_cfc_trd !:
+   INTEGER, PARAMETER ::   jp_lb      =  jp_pisces     + jp_cfc     !: cum. number of pass. tracers
+   INTEGER, PARAMETER ::   jp_lb_2d   =  jp_pisces_2d  + jp_cfc_2d  !:
+   INTEGER, PARAMETER ::   jp_lb_3d   =  jp_pisces_3d  + jp_cfc_3d  !:
+   INTEGER, PARAMETER ::   jp_lb_trd  =  jp_pisces_trd + jp_cfc_trd !:
    
 #if defined key_c14b
Index: branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/C14b/trcrst_c14b.F90
===================================================================
--- branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/C14b/trcrst_c14b.F90	(revision 3677)
+++ 	(revision )
@@ -1,85 +1,0 @@
-MODULE trcrst_c14b
-   !!======================================================================
-   !!                       ***  MODULE trcrst_c14b  ***
-   !! TOP :   create, write, read the restart files of c14b tracer
-   !!======================================================================
-   !! History :   1.0  !  2010-01 (C. Ethe) Original
-   !!----------------------------------------------------------------------
-#if defined key_c14b
-   !!----------------------------------------------------------------------
-   !!   'key_c14b'                                               c14b tracers
-   !!----------------------------------------------------------------------
-   !!   trc_rst_read_c14b   : read  restart file
-   !!   trc_rst_wri_c14b    : write restart file
-   !!----------------------------------------------------------------------
-   USE oce_trc         ! Ocean variables
-   USE par_trc         ! TOP parameters
-   USE trc             ! TOP variables
-   USE trcsms_c14b          ! c14b sms trends
-   USE iom
-
-   IMPLICIT NONE
-   PRIVATE
-
-   PUBLIC  trc_rst_read_c14b   ! called by trcini.F90 module
-   PUBLIC  trc_rst_wri_c14b   ! called by trcini.F90 module
-
-CONTAINS
-   
-   SUBROUTINE trc_rst_read_c14b( knum ) 
-      !!----------------------------------------------------------------------
-      !!                     ***  trc_rst_read_c14b  ***  
-      !!
-      !! ** Purpose : Read in restart file specific variables from c14b model
-      !!
-      !!----------------------------------------------------------------------
-      INTEGER, INTENT(in)  :: knum  ! unit of the restart file
-      INTEGER              :: jn    ! dummy loop indices
-      !!----------------------------------------------------------------------
-
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) ' trc_rst_read_c14b : Read specific variables from c14b model '
-      IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
-      
-      CALL iom_get( knum, jpdom_autoglo, 'qint_c14', qint_c14 ) 
-
-   END SUBROUTINE trc_rst_read_c14b
-
-   SUBROUTINE trc_rst_wri_c14b( kt, kitrst, knum )
-      !!----------------------------------------------------------------------
-      !!                     ***  trc_rst_read_c14b  ***
-      !!
-      !! ** Purpose : Read in restart file specific variables from c14b model
-      !!
-      !!----------------------------------------------------------------------
-      INTEGER, INTENT(in)  :: kt      ! time step
-      INTEGER, INTENT(in)  :: kitrst  ! time step of restart write
-      INTEGER, INTENT(in)  :: knum    ! unit of the restart file
-      !!----------------------------------------------------------------------
-
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) ' trc_rst_wri_c14b : Write specific variables from c14b model '
-      IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
-
-      CALL iom_rstput( kt, kitrst, knum, 'qint_c14', qint_c14 )
-
-   END SUBROUTINE trc_rst_wri_c14b
-
-#else
-   !!----------------------------------------------------------------------
-   !!  Dummy module :                                     No passive tracer
-   !!----------------------------------------------------------------------
-CONTAINS
-   SUBROUTINE trc_rst_read_c14b( knum )
-     INTEGER, INTENT(in)  :: knum
-     WRITE(*,*) 'trc_rst_wri_c14b: You should not have seen this print! error?', knum
-   END SUBROUTINE trc_rst_read_c14b
-
-   SUBROUTINE trc_rst_wri_c14b( kt, kitrst, knum )
-     INTEGER, INTENT(in)  :: kt, kitrst, knum
-     WRITE(*,*) 'trc_rst_wri_c14b: You should not have seen this print! error?', kt, kitrst, knum
-   END SUBROUTINE trc_rst_wri_c14b
-#endif
-
-   !!======================================================================
-END MODULE trcrst_c14b
Index: branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/C14b/trcsms_c14b.F90
===================================================================
--- branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/C14b/trcsms_c14b.F90	(revision 3677)
+++ branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/C14b/trcsms_c14b.F90	(revision 3680)
@@ -125,4 +125,14 @@
          xdecay  = EXP( - xlambda * rdt )
          xaccum  = 1._wp -  xdecay
+         !
+         IF( ln_rsttr ) THEN
+            IF(lwp) WRITE(numout,*)
+            IF(lwp) WRITE(numout,*) ' Read specific variables from C14b model '
+            IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
+            CALL iom_get( numrtr, jpdom_autoglo, 'qint_c14', qint_c14 )
+         ENDIF
+         !
+         IF(lwp) WRITE(numout,*)
+         !
       ENDIF
 
@@ -271,4 +281,13 @@
       END DO
 
+      !
+      IF( lrst_trc ) THEN
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'trc_sms_c14b : cumulated input function fields written in ocean restart file ',   &
+            &                    'at it= ', kt,' date= ', ndastp
+         IF(lwp) WRITE(numout,*) '~~~~'
+         CALL iom_rstput( kt, nitrst, numrtw, 'qint_c14', qint_c14 )
+      ENDIF
+      !    
       IF( ln_diatrc ) THEN
          IF( lk_iomput ) THEN
Index: branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/C14b/trcwri_c14b.F90
===================================================================
--- branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/C14b/trcwri_c14b.F90	(revision 3680)
+++ branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/C14b/trcwri_c14b.F90	(revision 3680)
@@ -0,0 +1,58 @@
+MODULE trcwri_c14b
+   !!======================================================================
+   !!                       *** MODULE trcwri ***
+   !!    c14b :   Output of c14b tracers
+   !!======================================================================
+   !! History :   1.0  !  2009-05 (C. Ethe)  Original code
+   !!----------------------------------------------------------------------
+#if defined key_top && key_c14b && defined key_iomput
+   !!----------------------------------------------------------------------
+   !!   'key_c14b'                                           c14b model
+   !!----------------------------------------------------------------------
+   !! trc_wri_c14b   :  outputs of concentration fields
+   !!----------------------------------------------------------------------
+   USE trc         ! passive tracers common variables 
+   USE iom         ! I/O manager
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC trc_wri_c14b 
+
+CONTAINS
+
+   SUBROUTINE trc_wri_c14b
+      !!---------------------------------------------------------------------
+      !!                     ***  ROUTINE trc_wri_trc  ***
+      !!
+      !! ** Purpose :   output passive tracers fields 
+      !!---------------------------------------------------------------------
+      CHARACTER (len=20)   :: cltra
+      INTEGER              :: jn
+      !!---------------------------------------------------------------------
+ 
+      ! write the tracer concentrations in the file
+      ! ---------------------------------------
+      DO jn = jp_c14b0, jp_c14b1
+         cltra = TRIM( ctrcnm(jn) )                  ! short title for tracer
+         CALL iom_put( cltra, trn(:,:,:,jn) )
+      END DO
+      !
+   END SUBROUTINE trc_wri_c14b
+
+#else
+   !!----------------------------------------------------------------------
+   !!  Dummy module :                                     No passive tracer
+   !!----------------------------------------------------------------------
+   PUBLIC trc_wri_c14b
+CONTAINS
+   SUBROUTINE trc_wri_c14b                     ! Empty routine  
+   END SUBROUTINE trc_wri_c14b
+#endif
+
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! $Id: trcwri_c14b.F90 3160 2011-11-20 14:27:18Z cetlod $ 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!======================================================================
+END MODULE trcwri_c14b